//
//   䠩 室 । ⠭ Dwarf v2.0,
// ᯮ㥬  ⫠ ᥢ ᥬ
// । ⠭   ⥫  DWARF_V2_CONST
//

macro DWARF_V2_CONST()

    // ⠭ 

const DW_TAG_array_type             = 01h;
const DW_TAG_class_type             = 02h;
const DW_TAG_entry_point            = 03h;
const DW_TAG_enumeration_type       = 04h;
const DW_TAG_formal_parameter       = 05h;
const DW_TAG_imported_declaration   = 08h;
const DW_TAG_label                  = 0ah;
const DW_TAG_lexical_block          = 0bh;
const DW_TAG_member                 = 0dh;
const DW_TAG_pointer_type           = 0fh;
const DW_TAG_reference_type         = 010h;
const DW_TAG_compile_unit           = 011h;
const DW_TAG_string_type            = 012h;
const DW_TAG_structure_type         = 013h;
const DW_TAG_subroutine_type        = 015h;
const DW_TAG_typedef                = 016h;
const DW_TAG_union_type             = 017h;
const DW_TAG_unspecified_parameters = 018h;
const DW_TAG_variant                = 019h;
const DW_TAG_common_block           = 01ah;
const DW_TAG_common_inclusion       = 01bh;
const DW_TAG_inheritance            = 01ch;
const DW_TAG_inlined_subroutine     = 01dh;
const DW_TAG_module                 = 01eh;
const DW_TAG_ptr_to_member_type     = 01fh;
const DW_TAG_set_type               = 020h;
const DW_TAG_subrange_type          = 021h;
const DW_TAG_with_stmt              = 022h;
const DW_TAG_access_declaration     = 023h;
const DW_TAG_base_type              = 024h;
const DW_TAG_catch_type             = 025h;
const DW_TAG_const_type             = 026h;
const DW_TAG_constant               = 027h;
const DW_TAG_enumerator             = 028h;
const DW_TAG_file_type              = 029h;
const DW_TAG_friend                 = 02ah;
const DW_TAG_namelist               = 02bh;
const DW_TAG_namelist_item          = 02ch;
const DW_TAG_packed_type            = 02dh;
const DW_TAG_subprogram             = 02eh;
const DW_TAG_template_type_parameter  = 02fh;
const DW_TAG_template_value_parameter = 030h;
const DW_TAG_thrown_type            = 031h;
const DW_TAG_try_block              = 032h;
const DW_TAG_variant_part           = 033h;
const DW_TAG_variable               = 034h;
const DW_TAG_volatile_type          = 035h;
const DW_TAG_lo_user                = 04080h;
const DW_TAG_NC_namespace           = 04081h;
const DW_TAG_NC_using               = 04082h;
const DW_TAG_hi_user                = 0ffffh;

    // ⠭ ਡ⮢

const DW_AT_sibling                 = 01h;
const DW_AT_location                = 02h;
const DW_AT_name                    = 03h;
const DW_AT_ordering                = 09h;
const DW_AT_byte_size               = 0bh;
const DW_AT_bit_offset              = 0ch;
const DW_AT_bit_size                = 0dh;
const DW_AT_stmt_list               = 010h;
const DW_AT_low_pc                  = 011h;
const DW_AT_high_pc                 = 012h;
const DW_AT_language                = 013h;
const DW_AT_discr                   = 015h;
const DW_AT_discr_value             = 016h;
const DW_AT_visibility              = 017h;
const DW_AT_import                  = 018h;
const DW_AT_string_length           = 019h;
const DW_AT_common_reference        = 01ah;
const DW_AT_comp_dir                = 01bh;
const DW_AT_const_value             = 01ch;
const DW_AT_containing_type         = 01dh;
const DW_AT_default_value           = 01eh;
const DW_AT_inline                  = 020h;
const DW_AT_is_optional             = 021h;
const DW_AT_lower_bound             = 022h;
const DW_AT_producer                = 025h;
const DW_AT_prototyped              = 027h;
const DW_AT_return_addr             = 02ah;
const DW_AT_start_scope             = 02ch;
const DW_AT_stride_size             = 02eh;
const DW_AT_upper_bound             = 02fh;
const DW_AT_abstract_origin         = 031h;
const DW_AT_accessibility           = 032h;
const DW_AT_address_class           = 033h;
const DW_AT_artificial              = 034h;
const DW_AT_base_types              = 035h;
const DW_AT_calling_convention      = 036h;
const DW_AT_count                   = 037h;
const DW_AT_data_member_location    = 038h;
const DW_AT_decl_column             = 039h;
const DW_AT_decl_file               = 03ah;
const DW_AT_decl_line               = 03bh;
const DW_AT_declaration             = 03ch;
const DW_AT_discr_list              = 03dh;
const DW_AT_encoding                = 03eh;
const DW_AT_external                = 03fh;
const DW_AT_frame_base              = 040h;
const DW_AT_friend                  = 041h;
const DW_AT_identifier_case         = 042h;
const DW_AT_macro_info              = 043h;
const DW_AT_namelist_item           = 044h;
const DW_AT_priority                = 045h;
const DW_AT_segment                 = 046h;
const DW_AT_specification           = 047h;
const DW_AT_static_link             = 048h;
const DW_AT_type                    = 049h;
const DW_AT_use_location            = 04ah;
const DW_AT_variable_parameter      = 04bh;
const DW_AT_virtuality              = 04ch;
const DW_AT_vtable_elem_location    = 04dh;
const DW_AT_lo_user                 = 02000h;
const DW_AT_hi_user                 = 03fffh;

    //  設 location expression

const DW_OP_addr        = 003h;
const DW_OP_deref       = 006h;
const DW_OP_const1u     = 008h;
const DW_OP_const1s     = 009h;
const DW_OP_const2u     = 00ah;
const DW_OP_const2s     = 00bh;
const DW_OP_const4u     = 00ch;
const DW_OP_const4s     = 00dh;
const DW_OP_const8u     = 00eh;
const DW_OP_const8s     = 00fh;
const DW_OP_constu      = 010h;
const DW_OP_consts      = 011h;
const DW_OP_dup         = 012h;
const DW_OP_drop        = 013h;
const DW_OP_over        = 014h;
const DW_OP_pick        = 015h;
const DW_OP_swap        = 016h;
const DW_OP_rot         = 017h;
const DW_OP_xderef      = 018h;
const DW_OP_abs         = 019h;
const DW_OP_and         = 01ah;
const DW_OP_div         = 01bh;
const DW_OP_minus       = 01ch;
const DW_OP_mod         = 01dh;
const DW_OP_mul         = 01eh;
const DW_OP_neg         = 01fh;
const DW_OP_not         = 020h;
const DW_OP_or          = 021h;
const DW_OP_plus        = 022h;
const DW_OP_plus_uconst = 023h;
const DW_OP_shl         = 024h;
const DW_OP_shr         = 025h;
const DW_OP_shra        = 026h;
const DW_OP_xor         = 027h;
const DW_OP_skip        = 02fh;
const DW_OP_bra         = 028h;
const DW_OP_eq          = 029h;
const DW_OP_ge          = 02ah;
const DW_OP_gt          = 02bh;
const DW_OP_le          = 02ch;
const DW_OP_lt          = 02dh;
const DW_OP_ne          = 02eh;
const DW_OP_lit0        = 030h;
const DW_OP_lit1        = 031h;
const DW_OP_lit2        = 032h;
const DW_OP_lit3        = 033h;
const DW_OP_lit4        = 034h;
const DW_OP_lit5        = 035h;
const DW_OP_lit6        = 036h;
const DW_OP_lit7        = 037h;
const DW_OP_lit8        = 038h;
const DW_OP_lit9        = 039h;
const DW_OP_lit10       = 03ah;
const DW_OP_lit11       = 03bh;
const DW_OP_lit12       = 03ch;
const DW_OP_lit13       = 03dh;
const DW_OP_lit14       = 03eh;
const DW_OP_lit15       = 03fh;
const DW_OP_lit16       = 040h;
const DW_OP_lit17       = 041h;
const DW_OP_lit18       = 042h;
const DW_OP_lit19       = 043h;
const DW_OP_lit20       = 044h;
const DW_OP_lit21       = 045h;
const DW_OP_lit22       = 046h;
const DW_OP_lit23       = 047h;
const DW_OP_lit24       = 048h;
const DW_OP_lit25       = 049h;
const DW_OP_lit26       = 04ah;
const DW_OP_lit27       = 04bh;
const DW_OP_lit28       = 04ch;
const DW_OP_lit29       = 04dh;
const DW_OP_lit30       = 04eh;
const DW_OP_lit31       = 04fh;
const DW_OP_reg0        = 050h;
const DW_OP_reg1        = 051h;
const DW_OP_reg2        = 052h;
const DW_OP_reg3        = 053h;
const DW_OP_reg4        = 054h;
const DW_OP_reg5        = 055h;
const DW_OP_reg6        = 056h;
const DW_OP_reg7        = 057h;
const DW_OP_reg8        = 058h;
const DW_OP_reg9        = 059h;
const DW_OP_reg10       = 05ah;
const DW_OP_reg11       = 05bh;
const DW_OP_reg12       = 05ch;
const DW_OP_reg13       = 05dh;
const DW_OP_reg14       = 05eh;
const DW_OP_reg15       = 05fh;
const DW_OP_reg16       = 060h;
const DW_OP_reg17       = 061h;
const DW_OP_reg18       = 062h;
const DW_OP_reg19       = 063h;
const DW_OP_reg20       = 064h;
const DW_OP_reg21       = 065h;
const DW_OP_reg22       = 066h;
const DW_OP_reg23       = 067h;
const DW_OP_reg24       = 068h;
const DW_OP_reg25       = 069h;
const DW_OP_reg26       = 06ah;
const DW_OP_reg27       = 06bh;
const DW_OP_reg28       = 06ch;
const DW_OP_reg29       = 06dh;
const DW_OP_reg30       = 06eh;
const DW_OP_reg31       = 06fh;
const DW_OP_breg0       = 070h;
const DW_OP_breg1       = 071h;
const DW_OP_breg2       = 072h;
const DW_OP_breg3       = 073h;
const DW_OP_breg4       = 074h;
const DW_OP_breg5       = 075h;
const DW_OP_breg6       = 076h;
const DW_OP_breg7       = 077h;
const DW_OP_breg8       = 078h;
const DW_OP_breg9       = 079h;
const DW_OP_breg10      = 07ah;
const DW_OP_breg11      = 07bh;
const DW_OP_breg12      = 07ch;
const DW_OP_breg13      = 07dh;
const DW_OP_breg14      = 07eh;
const DW_OP_breg15      = 07fh;
const DW_OP_breg16      = 080h;
const DW_OP_breg17      = 081h;
const DW_OP_breg18      = 082h;
const DW_OP_breg19      = 083h;
const DW_OP_breg20      = 084h;
const DW_OP_breg21      = 085h;
const DW_OP_breg22      = 086h;
const DW_OP_breg23      = 087h;
const DW_OP_breg24      = 088h;
const DW_OP_breg25      = 089h;
const DW_OP_breg26      = 08ah;
const DW_OP_breg27      = 08bh;
const DW_OP_breg28      = 08ch;
const DW_OP_breg29      = 08dh;
const DW_OP_breg30      = 08eh;
const DW_OP_breg31      = 08fh;
const DW_OP_regx        = 090h;
const DW_OP_fbreg       = 091h;
const DW_OP_bregx       = 092h;
const DW_OP_piece       = 093h;
const DW_OP_deref_size  = 094h;
const DW_OP_xderef_size = 095h;
const DW_OP_nop         = 096h;
const DW_OP_lo_user     = 0e0h;
const DW_OP_hi_user     = 0ffh;


    // ⠭ ஢  ⨯

const DW_ATE_address        = 01h;
const DW_ATE_boolean        = 02h;
const DW_ATE_complex_float  = 03h;
const DW_ATE_float          = 04h;
const DW_ATE_signed         = 05h;
const DW_ATE_signed_char    = 06h;
const DW_ATE_unsigned       = 07h;
const DW_ATE_unsigned_char  = 08h;
const DW_ATE_lo_user        = 080h;
const DW_ATE_hi_user        = 0ffh;


    // ⠭ 㯭 ꥪ⮢

const DW_ACCESS_public      = 1;
const DW_ACCESS_protected   = 2;
const DW_ACCESS_private     = 3;

    // ⠭  ꥪ⮢

const DW_VIS_local      = 1;
const DW_VIS_exported   = 2;
const DW_VIS_qualified  = 3;

    // ⠭ ⨯ 㠫쭮 㭪権

const DW_VIRTUALITY_none            = 0;
const DW_VIRTUALITY_virtual         = 1;
const DW_VIRTUALITY_pure_virtual    = 2;

    // ⠭ ஢ 室 몠 ணࠬ

const DW_LANG_C89           = 00001h;
const DW_LANG_C             = 00002h;
const DW_LANG_Ada83         = 00003h;
const DW_LANG_C_plus_plus   = 00004h;
const DW_LANG_Cobol74       = 00005h;
const DW_LANG_Cobol85       = 00006h;
const DW_LANG_Fortran77     = 00007h;
const DW_LANG_Fortran90     = 00008h;
const DW_LANG_Pascal83      = 00009h;
const DW_LANG_Modula2       = 0000ah;
const DW_LANG_lo_user       = 08000h;
const DW_LANG_hi_user       = 0ffffh;

    //  ⠭ ᭮ 

const DW_ADDR_none = 0;

    // ⠭ ஢ ॣ 䨪஢

const DW_ID_case_sensitive  = 0;
const DW_ID_up_case         = 1;
const DW_ID_down_case       = 2;
const DW_ID_case_insensitive= 3;

    // ⠭ ஢ 浪 맮 㭪樨

const DW_CC_nornal  = 01h;
const DW_CC_program = 02h;
const DW_CC_nocall  = 03h;
const DW_CC_lo_user = 040h;
const DW_CC_hi_user = 0ffh;

    // ⠭ ᠭ inline 㭪権

const DW_INL_not_inlined            = 0;
const DW_INL_inlined                = 1;
const DW_INL_declared_not_inlined   = 2;
const DW_INL_declared_inlined       = 3;

    // ⠭ 浪 ᮢ  ᨢ

const DW_ORD_row_major  = 0;
const DW_PRD_col_major  = 1;

    // ⠭ ਯ஢ ᯨ᪠ ਬ⮢

const DW_DSC_label  = 0;
const DW_DSC_range  = 1;

    //  設 ﭨ 饩 䮬  ⥪ 맮

const DW_CFA_nop                = 0;
const DW_CFA_advance_loc        = 040h;
const DW_CFA_offset             = 080h;
const DW_CFA_restore            = 0c0h;
const DW_CFA_set_loc            = 01h;
const DW_CFA_advance_loc1       = 02h;
const DW_CFA_advance_loc2       = 03h;
const DW_CFA_advance_loc4       = 04h;
const DW_CFA_offset_extended    = 05h;
const DW_CFA_restore_extended   = 06h;
const DW_CFA_undefined          = 07h;
const DW_CFA_same_value         = 08h;
const DW_CFA_register           = 09h;
const DW_CFA_remember_state     = 0ah;
const DW_CFA_restore_state      = 0bh;
const DW_CFA_def_cfa            = 0ch;
const DW_CFA_def_cfa_register   = 0dh;
const DW_CFA_def_cfa_offset     = 0eh;
const DW_CFA_lo_user            = 01ch;
const DW_CFA_hi_user            = 03fh;


//------------------------------------------------------------------------------
//
// ⮡ࠦ ॣ஢  ய NM6401
//  ⠭ ਢ  - 設-ᨬ
//
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
//  ⮡ࠦ ॣ஢ ᯮ㥬  ଠ樨  ⥪ 맮
//  ⠭ DW_FRAME 設-ᨬ
//------------------------------------------------------------------------------

const DW_FRAME_AR0  = 0;
const DW_FRAME_AR1  = 1;
const DW_FRAME_AR2  = 2;
const DW_FRAME_AR3  = 3;
const DW_FRAME_AR4  = 4;
const DW_FRAME_AR5  = 5;
const DW_FRAME_AR6  = 6;
const DW_FRAME_AR7  = 7;

const DW_FRAME_SP   = 7;    // ᨭ  ar7
const DW_FRAME_FP   = 6;    // ᨭ  ar6

const DW_FRAME_GR0  = 8;
const DW_FRAME_GR1  = 9;
const DW_FRAME_GR2  = 10;
const DW_FRAME_GR3  = 11;
const DW_FRAME_GR4  = 12;
const DW_FRAME_GR5  = 13;
const DW_FRAME_GR6  = 14;
const DW_FRAME_GR7  = 15;

const DW_FRAME_RA_COL   = 16;   //     
const DW_FRAME_CFA_COL  = 17;   //    CFA

// ᫮   ⠡ ३

const DW_FRAME_LAST_REG_NUM = (DW_FRAME_CFA_COL + 1);


//------------------------------------------------------------------------------
//  ⮡ࠦ ॣ஢ ᯮ㥬  location expresion
//  ⠭ DW_LOCREG 設-ᨬ
//------------------------------------------------------------------------------

const DW_LOCREG_AR0  = 0;
const DW_LOCREG_AR1  = 1;
const DW_LOCREG_AR2  = 2;
const DW_LOCREG_AR3  = 3;
const DW_LOCREG_AR4  = 4;
const DW_LOCREG_AR5  = 5;
const DW_LOCREG_AR6  = 6;
const DW_LOCREG_AR7  = 7;

const DW_LOCREG_SP   = 7;    // ᨭ  ar7

const DW_LOCREG_GR0  = 8;
const DW_LOCREG_GR1  = 9;
const DW_LOCREG_GR2  = 10;
const DW_LOCREG_GR3  = 11;
const DW_LOCREG_GR4  = 12;
const DW_LOCREG_GR5  = 13;
const DW_LOCREG_GR6  = 14;
const DW_LOCREG_GR7  = 15;

const DW_LOCREG_GR0AR0  = 16;
const DW_LOCREG_GR1AR1  = 17;
const DW_LOCREG_GR2AR2  = 18;
const DW_LOCREG_GR3AR3  = 19;
const DW_LOCREG_GR4AR4  = 20;
const DW_LOCREG_GR5AR5  = 21;
const DW_LOCREG_GR6AR6  = 22;
const DW_LOCREG_GR7AR7  = 23;

    // ᫮ ॣ஢  location descriptors
const DW_LOCREG_NUM = DW_LOCREG_GR7AR7 + 1;

//------------------------------------------------------------------------------
//
//  d dad
//
//------------------------------------------------------------------------------


end DWARF_V2_CONST;

