//////////////////////////////////////////////////////////////////////////
//                                                                      //
// modff.cpp -                                                          //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:08p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

#ifdef __cplusplus
extern "C" {
#endif

// modff --
//
//        
//
float modff(float f, float* i){
	int m, e, s, sc, r;
	DestructFloat(f, m, e, s, sc);

	if (e < 0){
		*i=0;                   //ConstructFloat(0, -127, s, 0);
		return f;
	}

	if (e > 22){
		if (e==128 && m!=0)     //NAN
			return f;
		*i=f;
		return 0;               //ConstructFloat(0, -127, s, 0);
	}
	
    //   
    r = m & (0x007fffff >> e);
	m -= r;

	//    
    *i = ConstructFloat(m, e, s, 0);

	r <<= e;
	sc=0;
	
	//    
    if (r){
		while (!(r & 0x00800000)){
			r <<=1;
			sc--;
		}
    	//    
		return ConstructFloat(r, sc, s, 0);
	}
	else
		return 0;
}

#ifdef __cplusplus
}
#endif
