/*
 *	Copyright (c) 1993-1996 by Research Computer Center (Expert Team)
 *	Moscow State University, Moscow, Russia
 *	All rights reserved.
 *
 *	%W%     %E%     (c) SRCC
 */

#include <exception>

#include <stdio.h>
#include <stdlib.h>

_USING_STD(terminate_handler)

static terminate_handler _terminate_handler = (terminate_handler) abort;

_NS_STD_BEGIN

terminate_handler
set_terminate (terminate_handler f)
{
    terminate_handler ret = _terminate_handler;

    if (f == 0) {
        // fprintf (stderr, "std::set_terminate(): 0 parameter");
        abort ();
    };

    _terminate_handler = f;
    return ret;
}

void
terminate ()
{
    _terminate_handler ();
}

_NS_STD_END
